PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Enumerations | Functions
safecoll.h File Reference
`#include <ptlib/syncthrd.h>`
Include dependency graph for safecoll.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
class | PSafeObject
| This class defines a thread-safe object in a collection. More...
class | PSafeLockReadOnly
| Lock a PSafeObject for read only and automatically unlock it when go out of scope. More...
class | PSafeLockReadWrite
| Lock a PSafeObject for read/write and automatically unlock it when go out of scope. More...
class | PSafeCollection
| This class defines a thread-safe collection of objects. More...
class | PSafePtrBase
| This class defines a base class for thread-safe pointer to an object. More...
class | PSafePtrMultiThreaded
| This class defines a base class for thread-safe pointer to an object. More...
class | PSafePtr< T, BaseClass >
| This class defines a thread-safe enumeration of object in a collection. More...
class | PSafeColl< Coll, Base >
| This class defines a thread-safe collection of objects. More...
class | PSafeArray< Base >
| This class defines a thread-safe array of objects. More...
class | PSafeList< Base >
| This class defines a thread-safe list of objects. More...
class | PSafeSortedList< Base >
| This class defines a thread-safe sorted array of objects. More...
class | PSafeDictionaryBase< Coll, Key, Base >
| This class defines a thread-safe dictionary of objects. More...
class | PSafeDictionary< K, D >
| This class defines a thread-safe array of objects. More...
class | PSafeDictionary< K, D >::iterator_base
class | PSafeDictionary< K, D >::iterator_pair
class | PSafeDictionary< K, D >::iterator
class | PSafeDictionary< K, D >::const_iterator

## Enumerations
enum | PSafetyMode { PSafeReference, PSafeReadOnly, PSafeReadWrite }

## Functions
template<class Base , class Derived >
PSafePtr< Derived > | PSafePtrCast (const PSafePtr< Base > &oldPtr)
| Cast the pointer to a different type. More...

## Enumeration Type Documentation

enum PSafetyMode

Enumerator
PSafeReference |
PSafeReadOnly |
PSafeReadWrite |

## Function Documentation

template<class Base , class Derived >

PSafePtr<Derived> PSafePtrCast | ( | const PSafePtr< Base > & | oldPtr | ) |

Cast the pointer to a different type.

The pointer being cast to MUST be a derived class or NULL is returned.